#ifndef UTILS_H
#define UTILS_H


#include <stdio.h>
#include <stdlib.h>

#include <dirent.h>
#include <errno.h>


#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <poll.h>
#include <unistd.h>

struct GPIO {
    int pin;
    int gpio;
    char gpio_s[7];
    
    int fd_value;
    char str_value[200];



    int fd_direction;
    char str_direction[200];

    int locked;
    int direction;
    int value;

    // ISR Like behavior
    struct pollfd poll_gpio;

};

#define HIGH '1'
#define LOW '0'

#define INPUT 1
#define OUTPUT 0

void test();
void fatal_error(int error_code, char * msg);
void init_GPIOs();
void digital_write(int port, char );
int digital_read(int port);
int pin_mode(int pin, int direction);
void set_direction(struct GPIO *pin, int direction);
void open_value(struct GPIO *pin);
void export_pin(struct GPIO * pin);
void display(const struct GPIO *pin);
void unpin_mode(int pin);
int is_gpio(int pin);
void destroy_gpios();
int wait_for_toggle(int pin, int timeout, void * (func)(void *), void * args);
#endif
